The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::SineWave Class Reference

STK sinusoid oscillator class. More...

`#include <SineWave.h>`

Inheritance diagram for stk::SineWave:

## Public Member Functions
| SineWave (void)
| Default constructor.
| ~SineWave (void)
| Class destructor.
void | reset (void)
| Clear output and reset time pointer to zero.
void | setRate (StkFloat rate)
| Set the data read rate in samples. The rate can be negative.
void | setFrequency (StkFloat frequency)
| Set the data interpolation rate based on a looping frequency.
void | addTime (StkFloat time)
| Increment the read pointer by time in samples, modulo the table size.
void | addPhase (StkFloat phase)
| Increment the read pointer by a normalized phase value.
void | addPhaseOffset (StkFloat phaseOffset)
| Add a normalized phase offset to the read pointer.
StkFloat | lastOut (void) const
| Return the last computed output value.
StkFloat | tick (void)
| Compute and return one output sample.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Fill a channel of the StkFrames object with computed outputs.
Public Member Functions inherited from stk::Generator
| Generator (void)
| Class constructor.
unsigned int | channelsOut (void) const
| Return the number of output channels for the class.
const StkFrames & | lastFrame (void) const
| Return an StkFrames reference to the last output sample frame.
virtual StkFrames & | tick (StkFrames &frames, unsigned int channel=0)=0
| Fill the StkFrames object with computed sample frames, starting at the specified channel.
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.

## Additional Inherited Members
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate.
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK sinusoid oscillator class.

This class computes and saves a static sine "table" that can be shared by multiple instances. It has an interface similar to the WaveLoop class but inherits from the Generator class. Output values are computed using linear interpolation.

The "table" length, set in SineWave.h, is 2048 samples by default.

by Perry R. Cook and Gary P. Scavone, 1995–2021.

## Member Function Documentation

## ◆ setRate()

void stk::SineWave::setRate | ( | StkFloat | rate | ) |
| inline

Set the data read rate in samples. The rate can be negative.

If the rate value is negative, the data is read in reverse order.

41{ rate_ = rate; };

## ◆ setFrequency()

void stk::SineWave::setFrequency | ( | StkFloat | frequency | ) |

Set the data interpolation rate based on a looping frequency.

This function determines the interpolation rate based on the file size and the current Stk::sampleRate. The frequency value corresponds to file cycles per second. The frequency can be negative, in which case the loop is read in reverse order.

## ◆ addPhase()

void stk::SineWave::addPhase | ( | StkFloat | phase | ) |

Increment the read pointer by a normalized phase value.

This function increments the read pointer by a normalized phase value, such that phase = 1.0 corresponds to a 360 degree phase shift. Positive or negative values are possible.

## ◆ addPhaseOffset()

void stk::SineWave::addPhaseOffset | ( | StkFloat | phaseOffset | ) |

Add a normalized phase offset to the read pointer.

A phaseOffset = 1.0 corresponds to a 360 degree phase offset. Positive or negative values are possible.

## ◆ tick()

StkFrames & stk::SineWave::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0`
| ) |  |
| inlinevirtual

Fill a channel of the StkFrames object with computed outputs.

The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Generator.

121{
122#if defined(_STK_DEBUG_)
123 if ( channel >= frames.channels() ) {
124 oStream_ << "SineWave::tick(): channel and StkFrames arguments are incompatible!";
125 handleError( StkError::FUNCTION_ARGUMENT );
126 }
127#endif
128
129 StkFloat *samples = &frames[channel];
130 StkFloat tmp = 0.0;
131
132 unsigned int hop = frames.channels();
133 for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
134
135 // Check limits of time address ... if necessary, recalculate modulo
136 // TABLE_SIZE.
137 while ( time_ < 0.0 )
138 time_ += TABLE_SIZE;
139 while ( time_ >= TABLE_SIZE )
140 time_ -= TABLE_SIZE;
141
142 iIndex_ = (unsigned int) time_;
143 alpha_ = time_ - iIndex_;
144 tmp = table_[ iIndex_ ];
145 tmp += ( alpha_ * ( table_[ iIndex_ + 1 ] - tmp ) );
146 *samples = tmp;
147
148 // Increment time, which can be negative.
149 time_ += rate_;
150 }
151
152 lastFrame_[0] = tmp;
153 return frames;
154}
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.

The documentation for this class was generated from the following file:

- SineWave.h

The Synthesis ToolKit in C++ (STK)
©1995--2021 Perry R. Cook and Gary P. Scavone. All Rights Reserved.